  
/*-------------------------------------------------------------------

  Function Purpose:  This function takes an implicit surface equation
		     and sends the equation to the polygonizer.

		     Two files will be produced, namely, 

                         ./res/myluiz.dat, ./res/mytran.dat

                     The former has all vertices and normals in it, 
                     while the latter gives which vertices construct 
                     each of the triangles.

  Parameters:	     x, y, z: 3-D coordinates. System will take care
                     of it.

  Return Value:      A point in space. System will take care of it.
                    
  Usage:             All you need to do is to define your equation
                     like the given example using C grammar.

  NOTE:

  * Do not forget to save your modifiction. 

  * In case you do not get the expected surface, adjust the values of
    your coefficients.

-------------------------------------------------------------------*/

#include <math.h>

double myfunc (double x, double y, double z)  
{
    double rsq;  /* return value    */

    /*------------------------------*/
    /* DO NOT MODIFY ANYTHING ABOVE */
    /*------------------------------*/

    /*----------------------------*/
    /* define your variables here */
    /*----------------------------*/
    double a, b, c, u;
    
    /*----------------------------*/
    /* write your equation below  */
    /*----------------------------*/

    /* Example: A cylclide with self-intersection  */
#if 1
    a = 1.0, c = 0.8, u = 0.4;          

    b = sqrt( a*a - c*c );
    rsq = ( x*x + y*y + z*z - u*u + b*b ) * ( x*x + y*y + z*z - u*u + b*b ) 
          - 4 * ( a*x - c*u ) * ( a*x - c*u ) 
          - 4 * b *b * y * y;
#else
    /* Example: A sphere */
    rsq = x*x + y*y + z*z -1;
#endif

    /*------------------------------*/
    /* DO NOT MODIFY ANYTHING BELOW */
    /*------------------------------*/

    return rsq;  /* must return this value */
}

